/*
 * RiskScape™ Copyright New Zealand Institute for Earth Science Limited
 * (Earth Sciences New Zealand) is distributed for research purposes only
 * under the terms of AGPLv3.
 *
 * RiskScape™ Copyright 2026 New Zealand Institute for Earth Science
 * Limited (Earth Sciences New Zealand). All rights reserved. Source code
 * available under the AGPLv3.
 * 
 * This program is free software: you can redistribute it and/or modify it under
 *  the terms of the GNU Affero General Public License as published by the Free
 *  Software Foundation, either version 3 of the License, or (at your option) any
 *  later version.
 * 
 * This program is distributed for RESEARCH PURPOSES ONLY, in the hope that it will
 * be useful for research and education initiatives.
 * 
 * If you are not a researcher, or you are a researcher who wishes to use this
 * program on terms other than AGPLv3 (including those who wish to restrict the
 * distribution of any source code created using this program), please contact:
 * https://riskscape.org.nz
 * 
 * This program is distributed WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Affero General Public License for more details.  You should have received a copy
 * of the GNU Affero General Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 * 
 * By way of summary only, under the AGPLv3:
 *     • Permissions of this strongest copyleft license are conditioned
 *       on making available complete source code of licensed works and
 *       modifications, which include larger works using a licensed work,
 *       under the same license.
 *     • Copyright and license notices must be preserved.
 *     • Contributors provide an express grant of patent rights.
 *     • When a modified version is used to provide a service over a
 *       network, the complete source code of the modified version must be made
 *       available.
 */
package nz.org.riskscape.engine.rl;

import java.util.Iterator;
import java.util.List;

import nz.org.riskscape.engine.Tuple;
import nz.org.riskscape.engine.function.ArgumentList;
import nz.org.riskscape.engine.function.BaseRealizableFunction;
import nz.org.riskscape.engine.function.RiskscapeFunction;
import nz.org.riskscape.engine.types.EmptyList;
import nz.org.riskscape.engine.types.LambdaType;
import nz.org.riskscape.engine.types.Nullable;
import nz.org.riskscape.engine.types.RSList;
import nz.org.riskscape.engine.types.ScopedLambdaType;
import nz.org.riskscape.engine.types.Struct;
import nz.org.riskscape.engine.types.Type;
import nz.org.riskscape.engine.types.TypeProblems;
import nz.org.riskscape.engine.types.Types;
import nz.org.riskscape.problem.ProblemException;
import nz.org.riskscape.problem.ResultOrProblems;
import nz.org.riskscape.rl.ast.ExpressionProblems;
import nz.org.riskscape.rl.ast.FunctionCall;
import nz.org.riskscape.rl.ast.FunctionCall.Argument;
import nz.org.riskscape.rl.ast.Lambda;

// Improvements:
//  - add a map arg to transform elements of the list before they are combined
//  - support type coercion to allow combine and values to have different types
public class Reduce extends BaseRealizableFunction {

  public Reduce() {
    super(ArgumentList.create(
        "values", RSList.LIST_ANYTHING,
        "combine", new LambdaType("lhs", "rhs")
      ),
      Types.ANYTHING);
  }

  @Override
  public ResultOrProblems<RiskscapeFunction> realize(RealizationContext context, FunctionCall functionCall,
      List<Type> givenTypes) {
    return ProblemException.catching(() -> {
      return build(context, functionCall, givenTypes);
    });
  }

  @Override
  public RiskscapeFunction build(RealizationContext context, FunctionCall functionCall,
      List<Type> givenTypes) throws ProblemException {

    getArguments().validateArity(givenTypes);

    // useless, but for completeness, return nothing for an empty list
    if (givenTypes.get(0) == EmptyList.INSTANCE) {
      return RiskscapeFunction.create(this, givenTypes, Types.NOTHING, args -> null);
    }

    // values required
    Argument valuesArg = getArguments().getRequiredArgument(functionCall, "values").getOrThrow();
    RSList valuesType = givenTypes.get(0).findAllowNull(RSList.class).orElseThrow(() ->
      new ProblemException(TypeProblems.get().mismatch(valuesArg, RSList.LIST_ANYTHING, givenTypes.get(0))));

    Type elementType = valuesType.getContainedType();
    Argument lambdaArg = getArguments().getRequiredArgument(functionCall, "combine").getOrThrow();

    // NB null lambda not supported - is this even a thing?
    ScopedLambdaType lambdaType = givenTypes.get(1).find(ScopedLambdaType.class).orElseThrow(() ->
        new ProblemException(TypeProblems.get().mismatch(
            lambdaArg,
            ScopedLambdaType.class,
            givenTypes.get(1).getClass())
        ));

    Lambda arg = functionCall.getArguments().get(1).getValue().isA(Lambda.class).get();

    if (arg.getArguments().size() != 2) {
      throw new ProblemException(ExpressionProblems.get().lambdaArityError(arg, arg.getArguments().size(), 2));
    }

    Struct inputScope = lambdaType.buildCallingScopeType(elementType, elementType);

    RealizedExpression combineExpression =
        context.getExpressionRealizer().realize(inputScope, arg.getExpression()).getOrThrow();

    // make sure the result of the lambda can be assigned to our result type
    // NB this is quite "brutal" and we could do a much better job here of helping the user, but this is good
    // enough for now
    if (!context.getTypeSet().isAssignable(combineExpression.getResultType(), elementType)) {
      throw new ProblemException(TypeProblems.get().mismatch(
          getArguments().getArgument(functionCall, "combine").get(),
          elementType,
          combineExpression.getResultType()
      ));
    }

    return RiskscapeFunction.create(this, givenTypes, Nullable.of(elementType), args -> {
      List<?> list = (List<?>) args.get(0);

      if (list == null) {
        return null;
      }

      // apply input scope
      ScopedLambdaExpression scope = (ScopedLambdaExpression) args.get(1);

      if (list.isEmpty()) {
        return null;
      } else  {
        Iterator<?> iterator = list.iterator();
        // aka accumulator - this is where we combine stuff
        Object reduction = null;

        while (iterator.hasNext()) {
          Object element = iterator.next();

          if (element == null) {
            continue;
          }

          // if the first element
          if (reduction == null) {
            reduction = element;
            continue;
          }

          Tuple toReduce = scope.buildCallingScope(inputScope, reduction, element);
          Object newResult = combineExpression.evaluate(toReduce);

          if (newResult != null) {
            reduction = newResult;
          }
        }

        return reduction;
      }
    });
  }

}
